"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.writeEnv = exports.constructEnvFromJson = void 0;
var fs = __importStar(require("fs"));
function constructEnvFromJson(db, hasuraPort) {
    return __awaiter(this, void 0, void 0, function () {
        var keys;
        return __generator(this, function (_a) {
            keys = {
                HASURA_GRAPHQL_DB_NAME: db.db_name,
                HASURA_GRAPHQL_METADATA_DATABASE_URL: "postgresql://".concat(db.username, ":").concat(db.password, "@host.docker.internal:").concat(db.port, "/").concat(db.db_name),
                HASURA_GRAPHQL_ADMIN_SECRET: "admin-secret",
                HASURA_GRAPHQL_URL: "http://localhost:".concat(hasuraPort),
                HASURA_GRAPHQL_JWT_SECRET: "{\\\"type\\\": \\\"HS256\\\", \\\"key\\\": \\\"ThisShouldBeAtLeast32CharacterLong\\\"}",
                HASURA_GRAPHQL_UNAUTHORIZED_ROLE: "guest",
                HASURA_GRAPHQL_LOG_LEVEL: "DEBUG",
                HASURA_GRAPHQL_ENABLE_CONSOLE: "true",
                HASURA_GRAPHQL_CORS_DOMAIN: "*",
                ACTION_BASE_URL: "http://engine:3500/v1.0/invoke/engine/method/actions",
                EVENT_BASE_URL: "http://engine:3500/v1.0/invoke/engine/method/events",
                HASURA_GRAPHQL_ENABLE_TELEMETRY: "false"
            };
            return [2, keys];
        });
    });
}
exports.constructEnvFromJson = constructEnvFromJson;
function writeEnv(graphqlInstance, db) {
    return __awaiter(this, void 0, void 0, function () {
        var path, port, env, keys;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    path = "".concat(graphqlInstance.getInstallationPath(), "/.env");
                    return [4, graphqlInstance.getContainerController().getPortNumber()];
                case 1:
                    port = _a.sent();
                    env = "";
                    return [4, graphqlInstance.getContainerController().getEnv()];
                case 2:
                    keys = _a.sent();
                    Object.keys(keys).forEach(function (key) {
                        env += "".concat(key, "=\"").concat(keys[key], "\"\n");
                    });
                    fs.writeFileSync(path, env);
                    return [2];
            }
        });
    });
}
exports.writeEnv = writeEnv;
//# sourceMappingURL=write-env.js.map